"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OuiResizableContainerContextProvider = OuiResizableContainerContextProvider;
Object.defineProperty(exports, "EuiResizableContainerContextProvider", {
  enumerable: true,
  get: function get() {
    return _context.EuiResizableContainerContextProvider;
  }
});
Object.defineProperty(exports, "useEuiResizableContainerContext", {
  enumerable: true,
  get: function get() {
    return _context.useEuiResizableContainerContext;
  }
});
exports.useOuiResizableContainerContext = void 0;

var _react = _interopRequireWildcard(require("react"));

var _context = require("../../eui_components/resizable_container/context");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/*
 * SPDX-License-Identifier: Apache-2.0
 *
 * The OpenSearch Contributors require contributions made to
 * this file be licensed under the Apache-2.0 license or a
 * compatible open source license.
 *
 * Modifications Copyright OpenSearch Contributors. See
 * GitHub history for details.
 */

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var OuiResizableContainerContext = /*#__PURE__*/(0, _react.createContext)({});

function OuiResizableContainerContextProvider(_ref) {
  var children = _ref.children,
      registry = _ref.registry;
  return /*#__PURE__*/_react.default.createElement(OuiResizableContainerContext.Provider, {
    value: {
      registry: registry
    }
  }, children);
}

var useOuiResizableContainerContext = function useOuiResizableContainerContext() {
  var context = (0, _react.useContext)(OuiResizableContainerContext);

  if (!context.registry) {
    throw new Error('useOuiResizableContainerContext must be used within a <OuiResizableContainerContextProvider />');
  }

  return context;
};
/* OUI -> EUI Aliases: Build-Time */


exports.useOuiResizableContainerContext = useOuiResizableContainerContext;