"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getSteppedGradient = void 0;

var _chromaJs = _interopRequireDefault(require("chroma-js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; } /*
                                                                                                                                                                                         * SPDX-License-Identifier: Apache-2.0
                                                                                                                                                                                         *
                                                                                                                                                                                         * The OpenSearch Contributors require contributions made to
                                                                                                                                                                                         * this file be licensed under the Apache-2.0 license or a
                                                                                                                                                                                         * compatible open source license.
                                                                                                                                                                                         *
                                                                                                                                                                                         * Modifications Copyright OpenSearch Contributors. See
                                                                                                                                                                                         * GitHub history for details.
                                                                                                                                                                                         */ /*
                                                                                                                                                                                             * Licensed to Elasticsearch B.V. under one or more contributor
                                                                                                                                                                                             * license agreements. See the NOTICE file distributed with
                                                                                                                                                                                             * this work for additional information regarding copyright
                                                                                                                                                                                             * ownership. Elasticsearch B.V. licenses this file to you under
                                                                                                                                                                                             * the Apache License, Version 2.0 (the "License"); you may
                                                                                                                                                                                             * not use this file except in compliance with the License.
                                                                                                                                                                                             * You may obtain a copy of the License at
                                                                                                                                                                                             *
                                                                                                                                                                                             *    http://www.apache.org/licenses/LICENSE-2.0
                                                                                                                                                                                             *
                                                                                                                                                                                             * Unless required by applicable law or agreed to in writing,
                                                                                                                                                                                             * software distributed under the License is distributed on an
                                                                                                                                                                                             * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
                                                                                                                                                                                             * KIND, either express or implied.  See the License for the
                                                                                                                                                                                             * specific language governing permissions and limitations
                                                                                                                                                                                             * under the License.
                                                                                                                                                                                             */

var getSteppedGradient = function getSteppedGradient(colors, steps) {
  var range = colors[colors.length - 1].stop - colors[0].stop;
  var offset = colors[0].stop;

  var finalStops = _toConsumableArray(colors.map(function (item) {
    return (item.stop - offset) / range;
  }));

  var color = _toConsumableArray(colors.map(function (item) {
    return item.color;
  }));

  return _chromaJs.default.scale(color).domain(finalStops).colors(steps);
};

exports.getSteppedGradient = getSteppedGradient;