"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "euiDragDropReorder", {
  enumerable: true,
  get: function get() {
    return _services.euiDragDropReorder;
  }
});
Object.defineProperty(exports, "euiDragDropMove", {
  enumerable: true,
  get: function get() {
    return _services.euiDragDropMove;
  }
});
Object.defineProperty(exports, "euiDragDropCopy", {
  enumerable: true,
  get: function get() {
    return _services.euiDragDropCopy;
  }
});
exports.ouiDragDropCopy = exports.ouiDragDropMove = exports.ouiDragDropReorder = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _services = require("../../eui_components/drag_and_drop/services");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

/*
 * SPDX-License-Identifier: Apache-2.0
 *
 * The OpenSearch Contributors require contributions made to
 * this file be licensed under the Apache-2.0 license or a
 * compatible open source license.
 *
 * Modifications Copyright OpenSearch Contributors. See
 * GitHub history for details.
 */

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var ouiDragDropReorder = function ouiDragDropReorder(list, startIndex, endIndex) {
  var result = (0, _toConsumableArray2.default)(list);

  var _result$splice = result.splice(startIndex, 1),
      _result$splice2 = (0, _slicedToArray2.default)(_result$splice, 1),
      removed = _result$splice2[0];

  result.splice(endIndex, 0, removed);
  return result;
};

exports.ouiDragDropReorder = ouiDragDropReorder;

var ouiDragDropMove = function ouiDragDropMove(sourceList, destinationList, dropResultSource, dropResultDestination) {
  var _ref;

  var sourceClone = (0, _toConsumableArray2.default)(sourceList);
  var destClone = (0, _toConsumableArray2.default)(destinationList);

  var _sourceClone$splice = sourceClone.splice(dropResultSource.index, 1),
      _sourceClone$splice2 = (0, _slicedToArray2.default)(_sourceClone$splice, 1),
      removed = _sourceClone$splice2[0];

  destClone.splice(dropResultDestination.index, 0, removed);
  return _ref = {}, (0, _defineProperty2.default)(_ref, dropResultSource.droppableId, sourceClone), (0, _defineProperty2.default)(_ref, dropResultDestination.droppableId, destClone), _ref;
};

exports.ouiDragDropMove = ouiDragDropMove;

var ouiDragDropCopy = function ouiDragDropCopy(sourceList, destinationList, dropResultSource, dropResultDestination, idModification) {
  var _ref2;

  var sourceClone = (0, _toConsumableArray2.default)(sourceList);
  var destClone = (0, _toConsumableArray2.default)(destinationList);
  destClone.splice(dropResultDestination.index, 0, _objectSpread(_objectSpread({}, sourceList[dropResultSource.index]), {}, (0, _defineProperty2.default)({}, idModification.property, idModification.modifier())));
  return _ref2 = {}, (0, _defineProperty2.default)(_ref2, dropResultSource.droppableId, sourceClone), (0, _defineProperty2.default)(_ref2, dropResultDestination.droppableId, destClone), _ref2;
};
/* OUI -> EUI Aliases: Build-Time */


exports.ouiDragDropCopy = ouiDragDropCopy;