## API Report File for "opensearch-dashboards"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { ComponentType } from 'react';
import { Ensure } from '@osd/utility-types';
import { FC } from 'react';
import { Observable } from 'rxjs';
import React from 'react';

// @public
export type BaseState = object;

// @public
export interface BaseStateContainer<State extends BaseState> {
    get: () => State;
    set: (state: State) => void;
    // Warning: (ae-unresolved-link) The @link reference could not be resolved: The package "opensearch-dashboards" does not have an export "Observable"
    state$: Observable<State>;
}

// @public
export type Comparator<Result> = (previous: Result, current: Result) => boolean;

// @public
export type Connect<State extends BaseState> = <Props extends object, StatePropKeys extends keyof Props>(mapStateToProp: MapStateToProps<State, Pick<Props, StatePropKeys>>) => (component: ComponentType<Props>) => FC<Omit<Props, StatePropKeys>>;

// @public
export function createStateContainer<State extends BaseState>(defaultState: State): ReduxLikeStateContainer<State>;

// @public
export function createStateContainer<State extends BaseState, PureTransitions extends object>(defaultState: State, pureTransitions: PureTransitions): ReduxLikeStateContainer<State, PureTransitions>;

// Warning: (ae-unresolved-link) The @link reference could not be resolved: The package "opensearch-dashboards" does not have an export "PureSelectors"
//
// @public
export function createStateContainer<State extends BaseState, PureTransitions extends object, PureSelectors extends object>(defaultState: State, pureTransitions: PureTransitions, pureSelectors: PureSelectors, options?: CreateStateContainerOptions): ReduxLikeStateContainer<State, PureTransitions, PureSelectors>;

// @public
export interface CreateStateContainerOptions {
    freeze?: <T>(state: T) => T;
}

// @public
export const createStateContainerReactHelpers: <Container extends StateContainer<any, any, {}>>() => {
    Provider: React.Provider<Container>;
    Consumer: React.Consumer<Container>;
    context: React.Context<Container>;
    useContainer: () => Container;
    useState: () => UnboxState<Container>;
    useTransitions: () => Container["transitions"];
    useSelector: <Result>(selector: (state: UnboxState<Container>) => Result, comparator?: Comparator<Result>) => Result;
    connect: Connect<UnboxState<Container>>;
};

// @public
export type Dispatch<T> = (action: T) => void;

// @public (undocumented)
export type EnsurePureSelector<T> = Ensure<T, PureSelector<any, any, any>>;

// Warning: (ae-incompatible-release-tags) The symbol "EnsurePureTransition" is marked as @public, but its signature references "PureTransition" which is marked as @internal
//
// @public (undocumented)
export type EnsurePureTransition<T> = Ensure<T, PureTransition<any, any>>;

// @public
export type MapStateToProps<State extends BaseState, StateProps extends object> = (state: State) => StateProps;

// Warning: (ae-incompatible-release-tags) The symbol "Middleware" is marked as @public, but its signature references "TransitionDescription" which is marked as @internal
//
// @public
export type Middleware<State extends BaseState = BaseState> = (store: Pick<ReduxLikeStateContainer<State, any>, 'getState' | 'dispatch'>) => (next: (action: TransitionDescription) => TransitionDescription | any) => Dispatch<TransitionDescription>;

// @public (undocumented)
export type PureSelector<State extends BaseState, Result, Args extends any[] = []> = (state: State) => Selector<Result, Args>;

// @public (undocumented)
export type PureSelectorsToSelectors<T extends object> = {
    [K in keyof T]: PureSelectorToSelector<EnsurePureSelector<T[K]>>;
};

// @public (undocumented)
export type PureSelectorToSelector<T extends PureSelector<any, any, any>> = ReturnType<EnsurePureSelector<T>>;

// @internal (undocumented)
export type PureTransition<State extends BaseState, Args extends any[]> = (state: State) => Transition<State, Args>;

// @internal (undocumented)
export type PureTransitionsToTransitions<T extends object> = {
    [K in keyof T]: PureTransitionToTransition<EnsurePureTransition<T[K]>>;
};

// @internal (undocumented)
export type PureTransitionToTransition<T extends PureTransition<any, any>> = ReturnType<T>;

// Warning: (ae-incompatible-release-tags) The symbol "Reducer" is marked as @public, but its signature references "TransitionDescription" which is marked as @internal
//
// @public
export type Reducer<State extends BaseState> = (state: State, action: TransitionDescription) => State;

// @public
export interface ReduxLikeStateContainer<State extends BaseState, PureTransitions extends object = {}, PureSelectors extends object = {}> extends StateContainer<State, PureTransitions, PureSelectors> {
    // (undocumented)
    addMiddleware: (middleware: Middleware<State>) => void;
    // Warning: (ae-incompatible-release-tags) The symbol "dispatch" is marked as @public, but its signature references "TransitionDescription" which is marked as @internal
    //
    // (undocumented)
    dispatch: (action: TransitionDescription) => void;
    // (undocumented)
    getState: () => State;
    // (undocumented)
    reducer: Reducer<State>;
    // (undocumented)
    replaceReducer: (nextReducer: Reducer<State>) => void;
    // (undocumented)
    subscribe: (listener: (state: State) => void) => () => void;
}

// @public (undocumented)
export type Selector<Result, Args extends any[] = []> = (...args: Args) => Result;

// @public
export interface StateContainer<State extends BaseState, PureTransitions extends object = object, PureSelectors extends object = {}> extends BaseStateContainer<State> {
    // (undocumented)
    selectors: Readonly<PureSelectorsToSelectors<PureSelectors>>;
    // Warning: (ae-incompatible-release-tags) The symbol "transitions" is marked as @public, but its signature references "PureTransitionsToTransitions" which is marked as @internal
    //
    // (undocumented)
    transitions: Readonly<PureTransitionsToTransitions<PureTransitions>>;
}

// @internal (undocumented)
export type Transition<State extends BaseState, Args extends any[]> = (...args: Args) => State;

// @internal (undocumented)
export interface TransitionDescription<Type extends string = string, Args extends any[] = any[]> {
    // (undocumented)
    args: Args;
    // (undocumented)
    type: Type;
}

// @public
export type UnboxState<Container extends StateContainer<any, any>> = Container extends StateContainer<infer T, any> ? T : never;

// @public
export const useContainerSelector: <Container extends StateContainer<any, any, {}>, Result>(container: Container, selector: (state: UnboxState<Container>) => Result, comparator?: Comparator<Result>) => Result;

// @public
export const useContainerState: <Container extends StateContainer<any, any, {}>>(container: Container) => UnboxState<Container>;


```
